﻿#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
; #Warn  ; Enable warnings to assist with detecting common errors.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

#include SCIaa.ahk ; aa for A as Algumist
    CoordMode, Pixel, Screen
    CoordMode, Mouse, Window
#singleinstance Force

SetBatchLines -1
HP := HT := 0, History := {}, HB := 1, HM := 30
gosub, init

Gui, +LastFound -DPIScale +hwndhGui +Resize +MinSize640x400
Gui, Color, 0xbbbbff, 0xfeffee
Gui, Font, % "s" fs:=16, arial new
Gui, Add, Text, c990000 gButtonGo, Filter:
w := a_screenwidth - 420-23 ;280 ; corrected by GuiSize anyway...
gui, add, edit, ym w%w% c000099 vNeedle gSearchAgain +hwndhEdt  , a e i o u s t h ;s e i
GuiControlGet, c, Pos, % ("Needle", Bw:= A_ScreenDPI*23/120)
;gui, add, ComboBox, c000099 w%w% vNeedle r10 gSearchAgain ym ; conflicts with other Hotkeys, no colors...
Gui, font, s10
Gui, add, Button, xp+%cw% yp w%Bw% h%ch% vBtDn g!Down, v
gui, add, Checkbox, c990000 ym-A_ScreenDPI*2/120 vCase gButtonGo, Case &s.
gui, add, Checkbox, c990000 y+A_ScreenDPI*8/120 vWhole gButtonGo, &Whole w.
Gui, Font, % "s" fs
Gui, Add, Text, ym+A_ScreenDPI*5/120 vhTxt gButtonGo, % "WWWWWWWWWWW"
GuiControl,, hTxt, % HP "/" HT "/" HM

SciLexer := A_ScriptDir . (A_PtrSize == 8 ? "\SciLexer64aa.dll" : "\SciLexer32aa.dll")
If (!LoadSciLexer(SciLexer)) {
	MsgBox 0x10, %g_AppName% - Error
    , % "Failed to load library """ . SciLexer . """.`n`n" ; . GetErrorMessage(A_LastError) . "`nThe program will exit."
	ExitApp
}
Sci := New Scintilla(hGui, 8, 8, 600,390, 0x50000000, 0x200)
DllCall("User32.dll\SendMessage", "Ptr", sci.hwnd, "Int", 8193, "Ptr", 0, "Ptr", 0x112b44)

Sci.SetCodePage(65001)
sci.SetWrapMode(SC_WRAP_WORD:= 3) ; \/ 
SCI.SETWRAPSTARTINDENT(5) ; \/

SCI.SETCARETLINEVISIBLE(true)
SCI.SETCARETLINEBACK(0xffff00)
SCI.SETCARETLINEBACKALPHA(30)
sci.UsePopUp(0)
;sci.SETHSCROLLBAR(3) ; \/
;sci.SetLexer(SCLEX_CONTAINER)
;sci.StyleClearAll()

    Sci.StyleSetFore(STYLE_DEFAULT, 0x880000)
    ;Sci.StyleSetBack(STYLE_DEFAULT, 0xF8F8F8)
    Sci.StyleSetBack(STYLE_DEFAULT, 0xeefeff)
    Sci.StyleSetSize(STYLE_DEFAULT, 16)
    Sci.StyleClearAll() ; This message sets all styles to have the same attributes as STYLE_DEFAULT.

;#MaxMem 4096
    ;sci.DOCUMENTOPTION_TEXT_LARGE() ; <------------- up to 2G

;sci.Home()
;sci.LineEnd()
;sci.HomeDisplay()
;sci.VcHomeWrap()

;sci.SETEDGECOLUMN(100) ; \/
;sci.SETEDGEMODE(1)

;sci.LineEndDisplay()
;sci.GrabFocus()
;sci.UsePopUp(0)
;SCI.MARKERSETBACK(0, 0x00ffff)
; Change a style
;sci.StyleSetSize(STYLE_DEFAULT, 18)
;SendMessage, 2055, 32, 18, , % "ahk_id " . sci.Hwnd

sci.SetZoom(zm:=0)
sci.SETCARETWIDTH(6)
SCI.SETMOUSEWHEELCAPTURES(1)
Sci.SCI_COPY(SCE_AHKL_USERDEFINED1)

        sci.StyleSetFore(SCE_AHKL_USERDEFINED1, 0x0000ff)
        sci.StyleSetBack(SCE_AHKL_USERDEFINED1, 0x00FFFF)
        sci.StyleSetFore(SCE_AHKL_USERDEFINED2, 0x0000ff)
        sci.StyleSetBack(SCE_AHKL_USERDEFINED2, 0x00FFFF)

GuiControl, Focus, Needle
;Gui, Show, % "x-5 y0 w" A_ScreenWidth " h" A_ScreenHeight-40, The Text Filter ( base %blc% lines )
Gui, Show, % "w" A_ScreenWidth-200 " h" A_ScreenHeight-140, The Text Filter ( base %blc% lines )
SCI.SETREADONLY(0)
            try sci.SetText( "", StrReplace(theHay, "`r"), 1 ) 
            Sleep, -1
SCI.SETREADONLY(1)
    Sci.StyleSetFore(33, 0x0) ; Margin foreground color
    Sci.StyleSetBack(33, 0xA8B2A8) ; Margin background color
    Sci.StyleSetSize(33, 12)
    ;Sci.SetMarginLeft(33, 0) ; ???
    ;Sci.SetMarginRight(33, 0) ; ???
    Sci.SetMarginRight("", 7) ; \/
    Sci.SetMarginLeft("", 7) ; \/
Sleep -1
Gosub SetWinTitle
;SCI.SETMARGINTYPEN(0, SC_MARGIN_RText) ; /
;sci.sETMARGINMASKN(1)
sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1), 1))
Sleep -1
;================= \/
;MsgBox % SCI.GETMARGINS()
;SCI.SETMARGINS()
;MsgBox % SCI.GETMARGINS()
;SCI.SETMARGINTYPEN(1, SC_MARGIN_NUMBER)
;MsgBox % SCI.GETMARGINTYPEN(1)
;SCI.SETMARGINTYPEN(1, SC_MARGIN_Text)
;MsgBox % SCI.GETMARGINTYPEN(1)
;SCI.SETMARGINTYPEN(1, SC_MARGIN_RText) ; /
;loop, 10
    ;sci.MARGINSETTEXT(1, "Test Text") ; /
;sci.SetMarginWidthN(1, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1), 1))
;================= \/

;SetTimer Tbm, 250 ; OnMessage is better, but scrollbar is not o.k.
;loop, 0xfffe
    ;OnMessage(A_Index, "TBM" )
    
    menu, SciMenu, Add, &Open
    ;menu, SciMenu, Default, &Open
    menu, SciMenu, Add, &Edit
    menu, SciMenu, Add, &GoTo
    menu, SciMenu, Add, &Save
    menu, SciMenu, Add, &Copy
    menu, SciMenu, Add, &Paste
    menu, SciMenu, Add, &Append
Return

GuiSize:
;WinMove, % "ahk_id " sci.hwnd,, 5, 5, % a_guiwidth - 10, % a_guiheight - 10
Sleep, -1
If WinExist("ahk_id " hGui)
    Gui nG: Destroy
WinGetPos, Guix, guiy, Guiw, Guih , ahk_id %hGui%
;WinMove, % "ahk_id " hsci,, % scix, % sciy, % sciw, % scih
GuiControl, Move, Needle, % "w" Guiw-A_ScreenDPI*(435+Bw)/120
GuiControl, Move, BtDn, % "x" Guiw-A_ScreenDPI*(435-96)/120
GuiControl, Move, Case, % "x" Guiw-A_ScreenDPI*295/120
GuiControl, Move, Whole, % "x" Guiw-A_ScreenDPI*295/120
GuiControl, Move, hTxt, % "x" Guiw-A_ScreenDPI*190/120
;GuiControl, Move, sci.hwnd, % "w" Guiw-35 Guih-130
;GuiControl, Move, SciCtrl, % "w" wGui-10 hGui-77
;WinMove, % "ahk_id " sci.hwnd,, % scix, % sciy, % sciw, % scih
;WinMove, % "ahk_id " sci.hwnd,, % guix+15, % guiy+75, % Guiw-60, % Guih-140
WinMove, % "ahk_id " sci.hwnd,
        , A_ScreenDPI*23/120, A_ScreenDPI*75/120, % Guiw-A_ScreenDPI*53/120, % Guih-A_ScreenDPI*140/120
WinSet Redraw,, % "ahk_id " hGui

;if !GetKeyState("LButton", "P") {
    ControlGetPos, scx, scy, scw, sch,, % "ahk_id " sci.hwnd
    Sci.GotoPos(0, 0)
    los:= sci.LINESONSCREEN(), lhg:= SCI.TextHeight(), fvs:= SCI.POSITIONFROMPOINT(0, 0), crp:= sci.GetCurrentPos()
    pvs:= sci.PositionFromPoint( 0, pvy:= lhg*los-1 ) ;, lve:= sci.PositionFromPoint( scw, lhgh*los-1)-1
    ;MsgBox % sci.GetwrapMode()
  sPos:= SCI.PositionFromPoint(0, 0), sci.GetWrapMode()? ePos:= sci.PositionFromPoint(scw, pvy+lhg)
: ePos:= SCI.PositionFromPoint(0, pvy+lhg*2) ;, cPos:= sPos ;sci.getCurrentPos()
  ;sPos:= SCI.PositionFromPoint(0, 0), sci.GetWrapMode()? ePos:= sci.PositionFromPoint(scw, sch)
;: ePos:= SCI.PositionFromPoint(0, sch) ;, cPos:= sci.getCurrentPos()
    SetTimer, Mark, -60
;}
return

Msg(w, l, m, h) {
    ;global sci, sciMsgs
    SoundBeep 4000, 30
    ;if (h=sci.hwnd)
      sciMsgs.= "w: " w "`tl: " l "`tm: "  m "`th: " h "`n"
}

AddToCombo:
    while InStr(Trim(Needle), "  ")
        Needle:= StrReplace(Trim(Needle), "  ", " ")
    if InStr("`n" nHist, "`n" Trim(Needle) "`n")
        nHist:= StrReplace("`n" nHist, "`n" Trim(Needle) "`n", "`n")
    nHist:= Trim(Needle) "`n" nHist
    while InStr(nHist, "`n`n")
        nHist:= StrReplace(nHist, "`n`n", "`n")
Return

Search:
    If WinExist("ahk_id " hGui)
        Gui nG: Destroy
	gui, submit, NoHide
    ;if ComboUpDate {
        ;ComboUpDate:= ""
        ;Return
    ;}
    Needle != ""? "": oNeedle:= ""
    while InStr(Trim(Needle), "  ")
        Needle:= StrReplace(Trim(Needle), "  ", " ")
    if (Needle = "") {
        if (TheNeedle = "")
            Return
        SCI.SETREADONLY(0), TheNeedle:= ""
    try sci.SetText( "", StrReplace(Haystack:= theHay, "`r"), 1 )
        Sleep, -1
        SCI.SETREADONLY(1)
        Gosub SetWinTitle
        sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1), 1))
        Return
     }
     if (oNeedle = Trim(Needle) && oNeedle != "")
        Return
     oNeedle:= Trim(Needle)
    ;Sleep, -1
    sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, 0, 1))
    ;MsgBox % Needle
    SetTimer AddToCombo, -1550
    InStr(Needle, "|")? (theNeedle:= StrReplace(Needle, "|", " "), sprt:= "|"): (theNeedle:= Needle, sprt:= A_Space)
    ;theNeedle:= StrReplace(Needle, "|", " "), sprt:= "|"): (theNeedle:= Needle, sprt:= A_Space)
  , pos:= ""
    
	r := "m`a" (case? "": "i") ")^(?!"
	loop, parse, theNeedle, % sprt
		if (substr(a_loopfield, 1, 1) = "-")
			r .= "(?!.*" (whole? "\b": "") substr(a_loopfield, 2) (whole? "\b": "") ")"
		else
			r .= "(?=.*" (whole? "\b": "") a_loopfield (whole? "\b": "") ")"
	r .= ").*\R?"

    theHaystack := regexreplace(theHay, r) ; seems better 
	lastHay:= Haystack := theHaystack ;, Needle := theNeedle

    SCI.SETREADONLY(0)
try sci.SetText( "", StrReplace(theHaystack, "`r"), 1 )
    Sleep, -1 ; let SetText take effect
    SCI.SETREADONLY(1)
    newSearch:= 1 ;NewMark:= 1
    Gosub SetWinTitle
    ;sci.GotoPos(0)
    Sleep, -1
    
    ControlGetPos, scx, scy, scw, sch,, % "ahk_id " sci.hwnd
    Sci.GotoPos(0, 0)
    los:= sci.LINESONSCREEN(), lhg:= SCI.TextHeight(), fvs:= SCI.POSITIONFROMPOINT(0, 0), crp:= sci.GetCurrentPos()
    pvs:= sci.PositionFromPoint( 0, pvy:= lhg*los-1 ) ;, lve:= sci.PositionFromPoint( scw, lhgh*los-1)-1
    ;MsgBox % sci.GetwrapMode()
  sPos:= SCI.PositionFromPoint(0, 0), sci.GetWrapMode()? ePos:= sci.PositionFromPoint(scw, pvy+lhg)
: ePos:= SCI.PositionFromPoint(0, pvy+lhg*2) ;, cPos:= sPos ;sci.getCurrentPos()
  ;sPos:= SCI.PositionFromPoint(0, 0), sci.GetWrapMode()? ePos:= sci.PositionFromPoint(scw, sch)
;: ePos:= SCI.PositionFromPoint(0, sch) ;, cPos:= sci.getCurrentPos() 
    ;---------------------------------------------------------------    
    ;los:= sci.LINESONSCREEN(), sci.GoToLine(0) ;, fvl:= sci.GETFIRSTVISIBLELINE()
  ;, sPos:= ePos:= sci.getSelectionStart() ;, ePos:= Sci.PositionFromLine(fvl+los+1) ; ???
    ;loop, % los+1 {
        ;ePos+= SCI.LINELENGTH(cntLin:= sci.GETFIRSTVISIBLELINE()+A_Index-1)
        ;cumLin+= Sci.WrapCount(cntLin)
        ;if (cumLin > los+1)
            ;Break
    ;}   cumLin:= "", cPos:= sci.PositionFromLine(sci.LineFromPosition(sPos))
    ;---------------------------------------------------------------
    ;if SCI.GETWRAPMODE() {
        ;sci.SetWrapMode(0)
        ;Sleep, 300
    ;}
        ;MsgBox % blc
    sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1), 1))
    Sleep, -1
    SetTimer Mark, -60
    ;Goto Mark
Return

#If WinExist("ahk_class #32768") && (fCtrl() != "Edit1")
~Up:: ; Enable selecting menu item
~Down:: 
~Esc:: Return

#If WinExist("ahk_class #32768 ahk_exe AutoHotkey.exe")
Up:: ControlSend,, {Up}, ahk_class #32768 ; Enable selecting menu item
Down:: ControlSend,, {Down}, ahk_class #32768
Esc:: WinActivate ahk_class #32768 ahk_exe AutoHotkey.exe ; \/
#If

Mark:
     Sleep -1

pSearch:= StrSplit(TheNeedle, sprt) ;, BackPos:= 1, RowCnt:= 0, Lpos:= 0, tRow:= sci.GETFIRSTVISIBLELINE()

    loop, % pSearch.Length() {
        if ((SearchText:= Trim(pSearch[A_Index], "^$"))="") ; Trim just most used regEx
            Continue

    If (!StringLength := StrPut(SearchText, "UTF-8") - 1) {
        sci.IndicatorClearRange(0, sci.GetLength())
        Return
    }
;=============================================================
        ;TextLength := sci.GetLength()
        ;sci.SetTargetRange(0, TextLength)
;=============================================================
        ;sci.GotoPos(TextLength)
        sci.SetTargetRange(sPos, TextLength:= ePos)
;=============================================================
        
        Length := StrPut(SearchText, "UTF-8") - 1
        VarSetCapacity(StrBuf, Length)
        StrPut(SearchText, &StrBuf, "UTF-8")

        ;While (sci.SearchInTarget(StringLength, "" . SearchText, 1) != -1) {
        While (sci.SearchInTarget(StringLength, &StrBuf) != -1) {

            TargetStart := sci.GetTargetStart()
            TargetEnd := sci.GetTargetEnd()

            TargetLength := TargetEnd - TargetStart

            If (!TargetLength) {
                sci.SetTargetRange(++TargetEnd, TextLength)
                Continue ; Zero-length match (Scintilla RegEx)
            }

            sci.StartStyling(TargetStart) ; colors from start to end
            sci.SetStyling(Length, SCE_AHKL_USERDEFINED1)
            sci.SetTargetRange(TargetEnd, TextLength)
        }

}
Return

BeepFinished:
    ;SoundBeep, 4444, 30
Return

SearchAgain:
     ;strt:= A_TickCount
    SetTimer, Search, -60
return

SetWinTitle:
    ;blc:= sci.getlinecount()-1
Try Haystack? StrReplace(RTrim(Haystack, "`r`n") "`n", "`n",, blc): blc:=0
    WinSetTitle, The Text Filter,, % "The Text Filter ( output: " blc " lines )"
    ;sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1)))
Return

ButtonGo: ; :: Label "Filter" and "History Info" replace button Go (are clickable)
    TheNeedle:= oNeedle:= "" ; XRR
    SetTimer, Search, -30
Return

;CheckPos:
    ;op:=np, np:= sci.GETFIRSTVISIBLELINE()
    ;if (np!=op)
        ;SetTimer, Mark, -60, 
;Return

;xTbm(w, l, m, h) {
    ;global sci, sciMsgs
    ;if (h=sci.hwnd)
        ;sciMsgs.= "w: " w "`tl: " l "`tm: "  m "`th: " h "`n"
;}

fCtrl() {
	controlgetfocus, foco, A
	return foco
}

Tbm() {
    Global op, np, sci
    op:=np, np:= sci.GETFIRSTVISIBLELINE()
    if (np!=op) 
        SetTimer, Mark, -60
}

;#If winactive("The Text Filter") && (fCtrl() = "Button1" || fCtrl() = "Static2")
#If winactive("ahk_id " hGui) && (fCtrl() = "Button1" || fCtrl() = "Static2")
Up:: ; Toggle focus of CheckBox
Left::
Down:: GuiControl, Focus, Whole

;#If winactive("The Text Filter") && (fCtrl() = "Button2" || fCtrl() = "Static2")
#If winactive("ahk_id " hGui) && (fCtrl() = "Button2" || fCtrl() = "Static2")
Right:: ; Toggle focus of CheckBox
Up::
Down::
^Tab:: GuiControl, Focus, Case
;#If

;#IfWinActive The Text Filter
#If winactive("ahk_id " hGui)
;guicancel:
GuiClose:
~Esc:: ; ExitApp
    MsgBox, 4,, Exit The Text Filter?
    ifMsgBox Yes
        exitapp
Return

F8:: ; toogle Wrap
Ins::
    cPos:= sci.PositionFromPoint(0, 0)
    if SCI.GETWRAPMODE() {
        ;MsgBox % SCI.gETWRAPSTARTINDENT(3)
        ;While !sci.PAINTED()
            ;sleep, 1
        sci.SetWrapMode(0)
        Sleep -1
        ;sci.GotoLine(3), wvl:= ""
        ;Hotkey Down, Down, On
        ;Hotkey Up, Up, On
    sci.GoToPos(cPos)
    ;ControlSend,, {Home}, % "ahk_id " sci.Hwnd ; \/
    sci.GoToPos(sci.PositionFromLine(sci.LineFromPosition(cPos))) ; \/
    ;cPos:= sci.PositionFromPoint(0, 0), sci.GoToPos(cPos)
    ;Sleep -1
    ControlGetPos,, scy, scw, sch,, % "ahk_id " sci.hwnd
    los:= sci.LINESONSCREEN(), lhg:= SCI.TextHeight(), crp:= sci.GetCurrentPos()

    sPos:= SCI.PositionFromPoint(0, 0), sci.GetWrapMode()? ePos:= sci.PositionFromPoint(scw, sch)
  : ePos:= SCI.PositionFromPoint(0, sch) ;, cPos:= sci.getCurrentPos() 
        
    SetTimer, Mark, -30
    } else {
        
        sci.SetWrapMode(SC_WRAP_WORD)
        SCI.sETWRAPSTARTINDENT(5)
        
        ;SCI.SETAUTOMATICFOLD(1)
        ;wvl:= sci.GETFIRSTVISIBLELINE(), sci.SetWrapMode(1)
        ;#IfWinActive The Text Filter ; ///
            ;Hotkey Down, Down, Off
            ;Hotkey Up, Up, Off
        ;#IfWinActive
    }
Return

Tab:: ; Toggle focus Between Scintilla or Edit Control
    if (fCtrl() = "Edit1") {
        ;SetTimer Tbm, Off
        ;DllCall("SetFocus", "Ptr", sci.hWnd) ;, SCI.GOTOLINE( SCI.LineFromPosition( SCI.GETCURRENTPOS() ))
         sci.GrabFocus(), Sci.GotoPos( sci.PositionFromPoint(0, 0) )
    } else {
       GuiControl, Focus, Needle
       ;SetTimer Tbm, -250
    }
Return

&Save:
^s:: ; set filter result as a new Haystack
    cTxt:= sciGetText(Sci)
    if !InStr(cTxt, "<-=-=-=-=-=-=-=-=-=-=-=-=-=-=->")
        frLn.1&&frLn.2? cTxt:= frLn.1 "`t" frLn.2 "`n<-=-=-=-=-=-=-=-=-=-=-=-=-=-=->`n" cTxt: ""
    SCI.SetReadOnly(0)
;try sci.SetText( "", StrReplace(theHay:= Haystack:= cTxt "`n" Clipboard, "`r"), 1 ), cTxt:= ""
try sci.SetText( "", StrReplace(theHay:= Haystack:= cTxt, "`r"), 1 ), cTxt:= ""
    Sleep, -1
    SCI.SetReadOnly(1), TheNeedle:= oNeedle:= ""
     History.InsertAt(++HP, theHay), ++HT>HM? (History.RemoveAt(HB), HT:=HM, HP>HM? HP:=HM: ""): ""
   , (HP<HT-5)? LastPos:= HP: ""
    GuiControl,, hTxt, % HP "/" HT "/" HM
    Gosub SetWinTitle
    sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1), 1))
Return

SciGetText(Sci) {
    nLen := Sci.GetLength() + 1
    VarSetCapacity(SciText, nLen, 0)
    Sci.GetText(nLen, &SciText)
    Return StrGet(&SciText, "UTF-8")
}

&Paste:
~^v:: ; Set Clipboard as Haystack
    if (fCtrl() = "Edit1")
        Return
    KeyWait, Ctrl
    sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, 0, 1))
    sleep, 150
    SCI.SetReadOnly(0)
try sci.SetText( "", StrReplace(theHay:= Haystack:= Clipboard, "`r"), 1 )
Sleep, -1
    SCI.SetReadOnly(1), TheNeedle:= oNeedle:= ""
     History.InsertAt(++HP, theHay), ++HT>HM? (History.RemoveAt(HB), HT:=HM, HP>HM? HP:=HM: ""): ""
   , (HP<HT-5)? LastPos:= HP: ""
    GuiControl,, hTxt, % HP "/" HT "/" HM
    Gosub SetWinTitle
    sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1), 1))
    GuiControl, Focus, Needle
Return

&Append:
^+v:: ; append Clipboard to Haystack
    sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, 0, 1))
   SCI.SetReadOnly(0)
   curTxt:= theHay ; \/
try sci.SetText( "", StrReplace(theHay:= Haystack:= curTxt "`n" Clipboard, "`r"), 1 ), curTxt:= ""
Sleep, -1
   SCI.SetReadOnly(1), TheNeedle:= oNeedle:= ""
     History.InsertAt(++HP, theHay), ++HT>HM? (History.RemoveAt(HB), HT:=HM, HP>HM? HP:=HM: ""): ""
   , (HP<HT-5)? LastPos:= HP: ""
    GuiControl,, hTxt, % HP "/" HT "/" HM
    Gosub SetWinTitle
    sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1), 1))
Return

^+o:: ; Set files in (Sub)Folder(s) to Haystack
    DllCall("SetFocus", "Ptr", sci.hWnd)
    r:= SelectFolderEx(,, hGui,"&SelectFolder", PreSetPaths,, "PreDefined &Paths")
    try fls:= "", oHay:= theHay, SCI.SetReadOnly(0) ;, Sci.SetText("", theHay:= Haystack:= "Loading...")
try sci.SetText( "", theHay:= Haystack:= "Loading...", 1 )
    Sleep, -1
    if (r.SelectedCombo = "FileName_Path")
        loop, Files, % r.SelectedDir "\*.*"
            fls.= A_LoopFileName "`t" A_LoopFileDir "`n"
    else if (r.SelectedCombo = "Path_FileName")
        loop, Files, % r.SelectedDir "\*.*"
            fls.= A_LoopFileDir "`t" A_LoopFileName "`n"
    else if (r.SelectedCombo = "FileName")
        loop, Files, % r.SelectedDir "\*.*"
            fls.= A_LoopFileName "`n"
    else if (r.SelectedCombo = "FileName_Path_R")
        loop, Files, % r.SelectedDir "\*.*", R
            fls.= A_LoopFileName "`t" A_LoopFileDir "`n"
    else if (r.SelectedCombo = "Path_FileName_R")
        loop, Files, % r.SelectedDir "\*.*", R
            fls.= A_LoopFileDir "`t" A_LoopFileName "`n"
    
    if fls
        try fls:= r.SelectedDir "`t" r.SelectedCombo "`n<-=-=-=-=-=-=-=-=-=-=-=-=-=-=->`n" fls
          , sci.SetText( "", StrReplace(theHay:= Haystack:= fls, "`r"), 1 ), oHay:= ""
    else try sci.SetText( "", StrReplace(theHay:= Haystack:= oHay, "`r"), 1 ), oHay:= ""
    Sleep, -1
    ;frLine:= " ", Sci.GetText(sci.GetLine(0), &frLine), frLn:= StrSplit(StrGet(&frLine, "UTF-8"), A_Tab)
    frLine:= " ", Sci.GetLine(0, &frLine), frLn:= StrSplit(StrGet(&frLine, "UTF-8"), A_Tab)
    sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, 0, 1))
    SCI.SetReadOnly(1), TheNeedle:= oNeedle:= ""
    if fls {
         History.InsertAt(++HP, theHay), ++HT>HM? (History.RemoveAt(HB), HT:=HM, HP>HM? HP:=HM: ""): ""
       , (HP<HT-5)? LastPos:= HP: ""
        GuiControl,, hTxt, % HP "/" HT "/" HM
    }
    Gosub SetWinTitle
    sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1), 1))
    GuiControl, Focus, Needle
    SendMessage, 0xB1, 1000, 1000,, ahk_id %hEdt%
Return

^o:: ; Set File(s) content(s) to Haystack
    DllCall("SetFocus", "Ptr", sci.hWnd)
    try oHay:= theHay, SCI.SetReadOnly(0), sci.SetText( "", theHay:= Haystack:= "Loading...", 1 )
    Sleep, -1
    mFs:=""
        FileSelectFile, mFs, M3, %Source%, Open a file
        If (ErrorLevel || !mFs) {
            try sci.SetText( "", StrReplace(theHay:= Haystack:= oHay, "`r"), 1 )
            Sleep, -1
            oHay:= "", SCI.SetReadOnly(1), TheNeedle:= oNeedle:= ""
            Return
        } else {
            SplitPath, mFs, mFN, mFD ; else convert to Multi-select format
            mFs:=mFD . "`n" . mFN
        }
if mFs {
    tf:= StrSplit(mFs, "`n"), hayTitle:= ""
    loop, 2
        tF[A_Index]:= tF[A_Index] "\", tF[A_Index]:= StrReplace(tF[A_Index], "\\", "\")
        
        loop, files, % tF.1 tf.2 tF.3
            fSize:= A_LoopFileSize
        VarSetCapacity(Haystack, fSize+2), VarSetCapacity(theHay, fSize+2)
        if (tf.Length() = 3) {
            fileread, Haystack, % tF.1 tf.2 tF.3
            hayTitle.= tF.1 tf.2 tF.3
        } else
            loop, % (tf.Length(), haystack:= "") {
                fileread, oneHay, % tF.1 tf.2 tF[A_Index+2]
                Haystack.= oneHay "`n", hayTitle.= tF[A_Index+2]? tF.1 tf.2 tF[A_Index+2] "`n": ""
            }
}

  sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, 0, 1))
    SCI.SetReadOnly(0)
try sci.SetText( "", StrReplace(theHay:= RTrim(hayTitle, "`n") "`n<-=-=-=-=-=-=-=-=-=-=-=-=-=-=->`n" Haystack, "`r"), 1 )
    Sleep, -1
    SCI.SetReadOnly(1), TheNeedle:= oNeedle:= ""
    GuiControl, Focus, Needle
try History.InsertAt(++HP, theHay), ++HT>HM? (History.RemoveAt(HB), HT:=HM, HP>HM? HP:=HM: ""): ""
   , (HP<HT-5)? LastPos:= HP: ""
    GuiControl,, hTxt, % HP "/" HT "/" HM
    Gosub SetWinTitle
    sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1), 1))
    GuiControl, Focus, Needle
    SendMessage, 0xB1, 1000, 1000,, ahk_id %hEdt%
return

XButton1::    ;<-- History Back
!Left::
  if (HP > HB) {
    fSize:= StrLen(History[--HP])
    VarSetCapacity(Haystack, fSize+2)
    VarSetCapacity(theHay, fSize+2)
    Haystack:= History[HP]
  } else {
    fSize:= StrLen(History[HP:= HT])
    VarSetCapacity(Haystack, fSize+2)
    VarSetCapacity(theHay, fSize+2)
    Haystack:= History[HP:= HT]
  }
    SCI.SetReadOnly(0)
    try sci.SetText( "", StrReplace(theHay:= Haystack, "`r"), 1 )
        ;try Sci.SetText( "", StrReplace(theHay:= Haystack, "`r") ) 
    Sleep, -1
    ;frLine:= " ", Sci.GetText(sci.GetLine(0), &frLine), frLn:= StrSplit(StrGet(&frLine, "UTF-8"), A_Tab)
    frLine:= " ", Sci.GetLine(0, &frLine), frLn:= StrSplit(StrGet(&frLine, "UTF-8"), A_Tab)
    SCI.SetReadOnly(1), TheNeedle:= oNeedle:= ""
    GuiControl,, hTxt, % HP "/" HT "/" HM
    Gosub SetWinTitle
    sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1), 1))
    GuiControl, Focus, Needle
return

XButton2::    ;<-- History Forward
!Right::
  if (HP < HT) {
    fSize:= StrLen(History[++HP])
    VarSetCapacity(Haystack, fSize+2)
    VarSetCapacity(theHay, fSize+2)
    Haystack:= History[HP]
  } else {
    fSize:= StrLen(History[HP:= HB])
    VarSetCapacity(Haystack, fSize+2)
    VarSetCapacity(theHay, fSize+2)
    Haystack:= History[HP]
  }
    SCI.SetReadOnly(0)
    try sci.SetText( "", StrReplace(theHay:= Haystack, "`r"), 1 )
            ;try Sci.SetText( "", StrReplace(theHay:= Haystack, "`r") ) 
    Sleep, -1
    ;frLine:= " ", Sci.GetText(sci.GetLine(0), &frLine), frLn:= StrSplit(StrGet(&frLine, "UTF-8"), A_Tab)
    frLine:= " ", Sci.GetLine(0, &frLine), frLn:= StrSplit(StrGet(&frLine, "UTF-8"), A_Tab)
    SCI.SetReadOnly(1), TheNeedle:= oNeedle:= ""
    GuiControl,, hTxt, % HP "/" HT "/" HM
    Gosub SetWinTitle
    sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1), 1))
    GuiControl, Focus, Needle
return

!Home:: ; <-- Jump to the "previous" history item
    if LastPos { 
        Haystack:= History[HP:=LastPos]
        SCI.SetReadOnly(0)
        try sci.SetText( "", StrReplace(theHay:= Haystack, "`r"), 1 )
        Sleep, -1
        ;frLine:= " ", Sci.GetText(sci.GetLine(0), &frLine), frLn:= StrSplit(StrGet(&frLine, "UTF-8"), A_Tab)
        frLine:= " ", Sci.GetLine(0, &frLine), frLn:= StrSplit(StrGet(&frLine, "UTF-8"), A_Tab)
        SCI.SetReadOnly(1), TheNeedle:= oNeedle:= ""
        GuiControl,, hTxt, % HP "/" HT "/" HM
        Gosub SetWinTitle
        sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1), 1))
        GuiControl, Focus, Needle
    }
Return

!End:: ; <-- Jump to the last history item ("previous")
    ¬ (HP<HT-3)? LastPos:= HP ; consider this, when the last position is set
    Haystack:= History[HP:=HT]
    SCI.SetReadOnly(0)
    try sci.SetText( "", StrReplace(theHay:= Haystack, "`r"), 1 )
    Sleep, -1
    ;frLine:= " ", Sci.GetText(sci.GetLine(0), &frLine), frLn:= StrSplit(StrGet(&frLine, "UTF-8"), A_Tab)
    frLine:= " ", Sci.GetLine(0, &frLine), frLn:= StrSplit(StrGet(&frLine, "UTF-8"), A_Tab)
    SCI.SetReadOnly(1), TheNeedle:= oNeedle:= ""
    GuiControl,, hTxt, % HP "/" HT "/" HM
    Gosub SetWinTitle
    sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1), 1))
    GuiControl, Focus, Needle    
Return
    ;KeyWait, Up ; Version with a single Hotkey
    ;KeyWait, Up, D, T.35
    ;if ErrorLevel { ; single press <-- Jump to the previous history item
        ;if LastPos { 
            ;Haystack:= History[HP:=LastPos]
            ;SCI.SetReadOnly(0)
            ;try sci.SetText( "", StrReplace(theHay:= Haystack, "`r"), 1 )
            ;Sleep, -1
            ;SCI.SetReadOnly(1)
            ;GuiControl, Focus, Needle
        ;}
    ;} else {  ; double press <-- Jump to the last history item
      ;¬ (HP<HT-5)? LastPos:= HP
        ;Haystack:= History[HP:=HT]
        ;SCI.SetReadOnly(0)
        ;try sci.SetText( "", StrReplace(theHay:= Haystack, "`r"), 1 )
        ;Sleep, -1
        ;SCI.SetReadOnly(1)
        ;GuiControl,, hTxt, % HP "/" HT "/" HM
        ;GuiControl, Focus, Needle
   ;}
;Return

!x::   ;<----- Delete Current History Item
!Del::
  if (HP>0) {
      if (HP > HB || HP = HB && HT = HB, hst:= 1) {
        RemovedValue := History.RemoveAt(HP), HT--, HP--
        HayStack := History[HP]
      }
      else if (HP = HB) && (HT > HB) {
        RemovedValue := History.RemoveAt(HP), HT--
        Haystack := History[HP]
      }
  } else Haystack := History[HP]
    SCI.SetReadOnly(0)
    try sci.SetText( "", StrReplace(theHay:= Haystack, "`r"), 1 )
    Sleep, -1
    SCI.SetReadOnly(1), TheNeedle:= oNeedle:= ""
    GuiControl,, hTxt, % HP "/" HT "/" HM
    Gosub SetWinTitle
    sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1), 1))
    GuiControl, Focus, Needle
return

^+Up::    ;<-- Increase history capacity (unlimited)
    HM<100? HM++: ""
    GuiControl,, hTxt, % HP "/" HT "/" HM
Return

^+Down::    ;<-- Reduce history capacity (not below currently saved items)
    HT<HM? HM--: ""
    GuiControl,, hTxt, % HP "/" HT "/" HM
Return

Return

TT_Off:
    ToolTip
Return

^Numpad0:: ; Reset Zoom
    czm:= sci.getzoom(), sci.SetZoom(zm:= 0)
    Sleep, -1
    if czm <= 0
        Return
    sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1), 1))
    Sleep -1
    ControlGetPos,, scy, scw, sch,, % "ahk_id " sci.hwnd
    los:= sci.LINESONSCREEN(), lhg:= SCI.TextHeight(), crp:= sci.GetCurrentPos()
    sPos:= SCI.PositionFromPoint(0, 0), sci.GetWrapMode()? ePos:= sci.PositionFromPoint(scw, sch)
  : ePos:= SCI.PositionFromPoint(0, sch) ;, cPos:= sci.getCurrentPos() 
    SetTimer, Mark, -30
Return

^+:: ; Zoom in
^WheelUp::
    sci.SetZoom(zm<20? ++zm: 20)
    Sleep -1
    sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1), 1))
Return
^-:: ; Zoom out
^WheelDown:: 
    sci.SetZoom(zm>-10? --zm: -10)
    Sleep, -1
    sci.SetMarginWidthN(0, sci.TextWidth(Style_LineNumber, SubStr("_99999999", 1, StrLen(blc "")+1), 1))
    Sleep, -1
    ControlGetPos,, scy, scw, sch,, % "ahk_id " sci.hwnd
    los:= sci.LINESONSCREEN(), lhg:= SCI.TextHeight(), crp:= sci.GetCurrentPos()

    sPos:= SCI.PositionFromPoint(0, 0), sci.GetWrapMode()? ePos:= sci.PositionFromPoint(scw, sch)
  : ePos:= SCI.PositionFromPoint(0, sch) ;, cPos:= sci.getCurrentPos() 
        
    SetTimer, Mark, -30
Return

~LButton:: ; supports coloring (after releasing LButton) when using scrollbar
    ControlGetPos, scx, scy, scw, sch,, % "ahk_id " sci.hwnd
    MouseGetPos, mx, my,, mc, 2
    if (mx < scx+scw-A_ScreenDPI*25/120 || !sci.getVscrollBar())
        Return
    KeyWait LButton
    Sleep, -1
    MouseGetPos, mx, my,, mc, 2
    los:= sci.LINESONSCREEN(), lhg:= SCI.TextHeight() ;, crp:= sci.GetCurrentPos()
    my<scy? pfp:=my: (my-scy)>sch? pfp:=sch-: pfp:=my ;, sci.gotoPos( sci.PositionFromPoint(0, pfp) )
    
    sPos:= SCI.PositionFromPoint(0, 0), sci.GetWrapMode()? ePos:= sci.PositionFromPoint(scw, sch)
  : ePos:= SCI.PositionFromPoint(0, sch) ;, cPos:= sci.getCurrentPos() 
  
    SetTimer, Mark, -30
Return

PgDn:: SetTimer, PageDown, -30
PageDown:
    ControlGetPos,, scy, scw, sch,, % "ahk_id " sci.hwnd
    los:= sci.LINESONSCREEN(), lhg:= SCI.TextHeight(), crp:= sci.GetCurrentPos()

    if sci.GetFocus() && crp < sci.PositionFromPoint(0, sch-lhg-1) { ; XRR
        sci.GotoPos( SCI.PositionFromPoint( sci.PointXFromPosition(crp), lhg*(los-1) ) )
        SoundBeep 2400, 30
        Return
    } else sci.PageDown()

    sPos:= SCI.PositionFromPoint(0, 0), sci.GetWrapMode()? ePos:= sci.PositionFromPoint(scw, sch)
  : ePos:= SCI.PositionFromPoint(0, sch) ;, cPos:= sci.getCurrentPos() 
            Gosub Mark
Return

PgUp:: SetTimer, PageUp, -30
PageUp:
    ControlGetPos,,, scw, sch,, % "ahk_id " sci.hwnd
    los:= sci.LINESONSCREEN(), lhg:= SCI.TextHeight(), crp:= sci.GetCurrentPos()
    
    if sci.GetFocus() && crp >= sci.PositionFromPoint(0, lhg) {
        sci.GotoPos( SCI.PositionFromPoint( sci.PointXFromPosition(crp), 0) )
        SoundBeep 2400, 30
        Return
    } else sci.PageUp()

    sPos:= SCI.PositionFromPoint(0, 0), sci.GetWrapMode()? ePos:= sci.PositionFromPoint(scw, sch)
  : ePos:= SCI.PositionFromPoint(0, sch) ;, cPos:= sci.getCurrentPos() 
          Gosub Mark
Return

    ;ControlGetPos, scx, scy, scw, sch,, % "ahk_id " sci.hwnd
    ;los:= sci.LINESONSCREEN(), lhg:= SCI.TextHeight(), fvs:= SCI.POSITIONFROMPOINT(0, 0), crp:= sci.GetCurrentPos()
    ;pvs:= sci.PositionFromPoint( 0, pvy:= lhg*los-1 ) ;, lve:= sci.PositionFromPoint( scw, lhgh*los-1)-1
    ;
    ;if (crp = sci.getLineEndPosition(sci.GetLineCount()))
        ;Return
    ;if (fCtrl() = "Edit1")
        ;sci.GotoPos( pvs )
      ;else if sci.GetFocus()
        ;if (crp >= fvs && crp < pvs) {
            ;sci.LineScroll(1, 1)
            ;Return
        ;} sci.LineScroll(1, 1)
        ;
    ;sPos:= SCI.PositionFromPoint(0, pvy+lhg), sci.GetWrapMode()? ePos:= sci.PositionFromPoint(scw, pvy+lhg)
  ;: ePos:= SCI.PositionFromPoint(0, pvy+lhg*2), cPos:= sci.getCurrentPos()
          ;Gosub Mark
;Return

$WheelDown::
    WinGetPos, wx, wy, ww, wh, ahk_id %hGui%
    CoordMode, Mouse, Screen
    MouseGetPos, mx, my,
    CoordMode, Mouse, Window
    if (mx<wx || my<wy || mx>wx+ww || my>wy+wh) {
        Send, {WheelDown}
        Return
    }
^Down::
    ControlGetPos, scx, scy, scw, sch,, % "ahk_id " sci.hwnd
    los:= sci.LINESONSCREEN(), lhg:= SCI.TextHeight(), fvs:= SCI.POSITIONFROMPOINT(0, 0), crp:= sci.GetCurrentPos()
    pvs:= sci.PositionFromPoint( 0, pvy:= lhg*los-1 ) ;, lve:= sci.PositionFromPoint( scw, lhgh*los-1)-1
    sci.LineScrollDown()
    sPos:= SCI.PositionFromPoint(0, pvy+lhg), sci.GetWrapMode()? ePos:= sci.PositionFromPoint(scw, pvy+lhg)
  : ePos:= SCI.PositionFromPoint(0, pvy+lhg*2) ;, cPos:= sci.getCurrentPos()
          Gosub Mark
Return

Down:: SetTimer, LineDown, -30
LineDown:
    ControlGetPos, scx, scy, scw, sch,, % "ahk_id " sci.hwnd
    los:= sci.LINESONSCREEN(), lhg:= SCI.TextHeight(), fvs:= SCI.POSITIONFROMPOINT(0, 0), crp:= sci.GetCurrentPos()
    pvs:= sci.PositionFromPoint( 0, pvy:= lhg*los-1 ) ;, lve:= sci.PositionFromPoint( scw, lhgh*los-1)-1
    
    if (crp = sci.getLineEndPosition(sci.GetLineCount()))
        Return
    if (fCtrl() = "Edit1")
        sci.GotoPos( pvs )
      else if sci.GetFocus()
        if (crp >= fvs && crp < pvs) {
                sci.LineDown()
            Return
        } sci.LineDown()
        
    sPos:= SCI.PositionFromPoint(0, pvy+lhg), sci.GetWrapMode()? ePos:= sci.PositionFromPoint(scw, pvy+lhg)
  : ePos:= SCI.PositionFromPoint(0, pvy+lhg*2) ;, cPos:= sci.getCurrentPos()
          Gosub Mark
Return

$WheelUp::
    WinGetPos, wx, wy, ww, wh, ahk_id %hGui%
    CoordMode, Mouse, Screen
    MouseGetPos, mx, my,
    CoordMode, Mouse, Window
    if (mx<wx || my<wy || mx>wx+ww || my>wy+wh) {
        Send, {WheelUp}
        Return
    }
^Up::
    ControlGetPos, scx, scy, scw, sch,, % "ahk_id " sci.hwnd
    los:= sci.LINESONSCREEN(), lhg:= SCI.TextHeight(), fvs:= SCI.POSITIONFROMPOINT(0, 0), crp:= sci.GetCurrentPos()
    pvs:= sci.PositionFromPoint( 0, pvy:= lhg )
        sci.LineScrollUp()
    sPos:= SCI.PositionFromPoint(0, 0), sci.GetWrapMode()? ePos:= sci.PositionFromPoint(scw, 0)
  : ePos:= SCI.PositionFromPoint(0, pvy) ;, cPos:= sci.getCurrentPos()
          Gosub Mark
Return

Up:: SetTimer, LineUp, -30
LineUp:
    ControlGetPos, scx, scy, scw, sch,, % "ahk_id " sci.hwnd
    los:= sci.LINESONSCREEN(), lhg:= SCI.TextHeight(), fvs:= SCI.POSITIONFROMPOINT(0, 0), crp:= sci.GetCurrentPos()
    pvs:= sci.PositionFromPoint( 0, pvy:= lhg )

    if (crp <= sci.getLineEndPosition(0))
        Return
    if (fCtrl() = "Edit1")
        sci.GotoPos( fvs )
      else if sci.GetFocus()
        if !(crp >= fvs && crp < pvs) {
            sci.LineUp()
            Return
        }
        sci.LineUp()

    sPos:= SCI.PositionFromPoint(0, 0), sci.GetWrapMode()? ePos:= sci.PositionFromPoint(scw, 0)
  : ePos:= SCI.PositionFromPoint(0, pvy) ;, cPos:= sci.getCurrentPos()
          Gosub Mark
Return

^End:: SetTimer, EndLine, -30
EndLine:
    sci.GotoPos( ePos:= cPos:= sci.GetLength() ), sPos:= SCI.PositionFromPoint(0, 0)
        Gosub, Mark
Return

^Home:: SetTimer, HomeLine, -30
HomeLine:
    ControlGetPos,,, scw, sch,, % "ahk_id " sci.hwnd
    los:= sci.LINESONSCREEN(), lhg:= SCI.TextHeight(), fvs:= SCI.POSITIONFROMPOINT(0, 0), crp:= sci.GetCurrentPos()
    pvs:= sci.PositionFromPoint( 0, pvy:= lhg*los-1 )
    
  sci.GotoPos( sPos:= cPos:= 0), sci.GetWrapMode()? ePos:= sci.PositionFromPoint(scw, lhg)
: ePos:= SCI.PositionFromPoint(0, pvy+lhg*2)

        Gosub, Mark
Return
    ;sci.GotoPos(0) ;, cPos:= sci.GetCurrentPos()
    ;los:= sci.LINESONSCREEN(), fvl:= sci.GETFIRSTVISIBLELINE()
    ;sPos:= cPos, ePos:= Sci.PositionFromLine(los)
    ;GoSub Mark
Return

~Bs::
~Del::
~enter::
    if (fCtrl()="Edit1")
         SetTimer, Search, -0
Return

GetTextRange(Range, Sci, Text:= " ", Sci_TextRange:= "    ") { ; Algumist, RRR
    ;VarSetCapacity(Text, Abs(Range.1 - Range.2) + 1, 0), VarSetCapacity(Sci_TextRange, 8 + A_PtrSize, 0)
    NumPut(Range.1, Sci_TextRange, 0, "UInt"), NumPut(Range.2, Sci_TextRange, 4, "UInt")
    NumPut(&Text, Sci_TextRange, 8, "Ptr"), Sci.GetTextRange(0, &Sci_TextRange) ; 2162
    Return StrGet(&Text,, "UTF-8")
}

$RButton:: ; Show Menu
    ;MsgBox % GetTextRange([0, 57], Sci) ; \/
    ;Return

    ;VarSetCapacity(t, SCI.GETLINE(nl)-1, 0)
    ;nl:= 0, t:= " ", SCI.GETLINE(nl, &t), tl:= StrGet(&t, "utf-8") ; \/
    ;sci.GoToPos(12)
    ;Return
    ;cl:= " " ;VarSetCapacity(cl, SCI.GETCurLINE()-1, 0)
    ;, sci.GETCURLINE(sci.GetCurLine()-1, &cl), crLn:= StrGet(&cL, "UTF-8"), A_Tab ; \/
    ;MsgBox % tl ;crLn
    ;Return
    ;if (!sci.GetFocus() || cMenu, cMenu:= "") { ;&& A_ThisLabel = "AppsKey"
    ControlGetPos, scx, scy, scw, sch,, % "ahk_id " sci.hwnd
    MouseGetPos, mx, my
    if (my<scy) {  ; XRR
        GuiControl, Focus, Needle
        Send {RButton}
        Return
    }
    if !(sci.GETSELECTIONNEND() - sci.GETSELECTIONNSTART())
        ;Send, {Click}
        sci.GoToPos(sci.PositionFromPoint(mx-scx, my-scy)), sci.GrabFocus()
    menu, SciMenu, % ("show", cMenu:= 1)
$AppsKey::
    if (!sci.GetFocus() || cMenu, cMenu:= "") { ;&& A_ThisLabel = "AppsKey"
        Send {AppsKey} ; XRR
        Return
    }
    menu, SciMenu, show, % A_CaretX+SCI.TextHeight()/2, % A_CaretY+SCI.TextHeight()
Return


&Open:
    crLine:= " ", sci.GETCURLINE(sci.GetCurLine()-1, &crLine), crLn:= StrSplit(StrGet(&crLine, "UTF-8"), A_Tab)

    if !InStr(frLn.2, "FileName") && !InStr(frLn.2, "_")
        Return
    else if InStr(frLn.2, "Path_FileName")
        Pth:= crLn.1, fl:= crLn.2
    else if InStr(frLn.2, "FileName_Path")
        Pth:= crLn.2, fl:= crLn.1
    else if !InStr(frLn.2, "_")
        Pth:= frLn.1, fl:= crLn.1
    if FileExist(Pth "\" fl)
        Run, % fl, % Pth
Return

&Edit:
    crLine:= " ", sci.GETCURLINE(sci.GetCurLine()-1, &crLine), crLn:= StrSplit(StrGet(&crLine, "UTF-8"), A_Tab)

    if !InStr(frLn.2, "FileName") && !InStr(frLn.2, "_")
        Return
    else if InStr(frLn.2, "Path_FileName")
        Pth:= crLn.1, fl:= crLn.2
    else if InStr(frLn.2, "FileName_Path")
        Pth:= crLn.2, fl:= crLn.1
    else if !InStr(frLn.2, "_")
        Pth:= frLn.1, fl:= crLn.1
    if FileExist(Pth "\" fl)
        Run, c:\Program Files\Notepad2\notepad2.exe "%Pth%\%fl%"
        ;Run, c:\Windows\notepad.exe "%Pth%\%fl%"
Return

&GoTo:
    crLine:= " ", sci.GETCURLINE(sci.GetCurLine()-1, &crLine), crLn:= StrSplit(StrGet(&crLine, "UTF-8"), A_Tab)

    if !InStr(frLn.2, "FileName") && !InStr(frLn.2, "_")
        Return
    else if InStr(frLn.2, "Path_FileName")
        Pth:= crLn.1, fl:= crLn.2
    else if InStr(frLn.2, "FileName_Path")
        Pth:= crLn.2, fl:= crLn.1
    else if !InStr(frLn.2, "_")
        Pth:= frLn.1, fl:= crLn.1
    if !FileExist(Pth "\" fl)
        Return
    Run, % Pth
    WinWaitActive, ahk_class CabinetWClass ahk_exe Explorer.EXE,, 1
    Sleep, 30
    ControlFocus, DirectUIHWND3, ahk_class CabinetWClass ahk_exe Explorer.EXE
    Sleep, 30
    aKeyDelay:= A_KeyDelay, aKeyDurattion:= A_KeyDuration
    SetKeyDelay, 30, 30
    Send % "{Raw}" fl
    SetKeyDelay, aKeyDelay, aKeyDurattion
Return

&Copy:
    selLength:= sci.GETSELECTIONNEND() - sci.GETSELECTIONNSTART() 
    SelText:= " ", Sci.GetSelText("", &SelText), Clipboard:= StrGet(&SelText, SelLength, "UTF-8")
Return

SciGetLineText(Sci, LineText:=" ") { ; relying on Ahk auto expansion of the var
    sci.GETCURLINE(sci.GetCurLine()-1, &LineText)
    Return % StrGet(&LineText, "UTF-8")
}

;#If winactive("ahk_id " hGui)
F2:: ; Open Needle history
#If winactive("ahk_id " hGui) && (fCtrl() = "Edit1")
!Down::
    GuiControl Focus, Needle
    if If WinExist("ahk_id " hGui) && WinExist("ahk_id " hnGui)
        Goto CloseNeedleHistor
    ControlGetPos, ex, ey, ew, eh, Edit1, ahk_id %hGui%
    WinGetPos, wx, wy,,, ahk_id %hGui%
    StrReplace(nHist, "`n", "`n", rr), ++rr>10? rr:=10: "", ew+=23
    Gui nG: Margin, 0, 0
    Gui nG: Font, % "s" fs, Consola
    Gui nG: Color, 0xfefffe, 0xddeecc
    Gui nG: -DPIScale +hwndhnGui -Caption +Owner1 ;%hGui%
    Gui nG: Add, Edit, r%rr% c000099 w%ew% vnEdt +VScroll +hwndhnEdt ;gnEdit
    GuiControl, nG:, nEdt, % nHist
    Gui nG: Show, % "x" wx+ex " y" wy+ey+eh, NeedleGui ; dynamic \/
    SendMessage, 0xB1, 0, 0,, ahk_id %hnEdt%
Return

#If WinExist("ahk_id " hGui) && WinActive("ahk_id " hnGui)
F2:: ; Close Needle history
#If winactive("ahk_id " hnGui)
;#IfWinActive NeedleGui
CloseNeedleHistor:
!Up::
Esc:: Gui nG: Destroy

~LButton:: ; Select and apply Needle history item
    KeyWait, LButton
    GuiControl, -Default, BtDn ;% "Button" nBt
    If !WinActive("ahk_id " hnGui)
        Return
Enter::
    ControlGet, nLn, CurrentLine,, Edit1, ahk_id %hnGui%
    ControlGet, hNeedle, Line, % nLn, Edit1, ahk_id %hnGui%
    if (hNeedle = "")
        Return
    Gui nG: Destroy
    GuiControl,, Needle, % hNeedle
Return
#If ;WinActive

nEdit:

fixCaret: ; not needed
        DllCall("SetFocus", "Ptr", sci.hWnd), SCI.GOTOLINE(sci.GETFIRSTVISIBLELINE())
Return

txtArr(r, i:="  ", d:=0, b:="") {
	For k, v in (r, IsObject(r)? "": e:= 1)
		c.= IsObject(v)? b k ":`n" txtArr(v, i, d+1, b i): b k ": " v "`n", d>0? "": t:=c
    Return e? r: d>0? c: t
}
pa(in) {
    MsgBox % txtArr(in)
}

#IfWinActive Select Folder ahk_class #32770 ahk_exe autohotkey.exe
!f:: ControlFocus Edit1, Select Folder ahk_class #32770 ahk_exe autohotkey.exe
#IfWinActive ; :: focus Edit control in Select Folder (workaround)

SelectFolderEx(StartingFolder:="", Prompt:="", OwnerHwnd:=0, OkBtnLabel:="", comboList:="", desiredDefault:=1
                 , comboLabel:="", CustomPlaces:="", pickFoldersOnly:=1) { ; by just me, RRR, robodesign
                 
   Static OsVersion := DllCall("GetVersion", "UChar")
        , IID_IShellItem := 0
        , InitIID := VarSetCapacity(IID_IShellItem, 16, 0)
        & DllCall("Ole32.dll\IIDFromString", "WStr", "{43826d1e-e718-42ee-bc55-a1e261c37bfe}", "Ptr", &IID_IShellItem)
        , Show := A_PtrSize * 3
        , SetOptions := A_PtrSize * 9
        , SetFolder := A_PtrSize * 12
        , SetTitle := A_PtrSize * 17
        , SetOkButtonLabel := A_PtrSize * 18
        , GetResult := A_PtrSize * 20
        , ComDlgObj := {COMDLG_FILTERSPEC: "*.ahk"}

   If (OsVersion<6)
   {
      ; IFileDialog requires Win Vista+, so revert to FileSelectFolder
      FileSelectFolder, SelectedFolder, *%StartingFolder%, 3, %Prompt%
      Return SelectedFolder
   }

   OwnerHwnd := DllCall("IsWindow", "Ptr", OwnerHwnd, "UInt") ? OwnerHwnd : 0
   If !(FileDialog := ComObjCreate("{DC1C5A9C-E88A-4dde-A5A1-60F82A20AEF7}", "{42f85136-db7e-439c-85f1-e4075d135fc8}"))
      Return ""

   VTBL := NumGet(FileDialog + 0, "UPtr")
   ;dialogOptions := 0x8 | 0x800 | 0x200 ;  FOS_NOCHANGEDIR | FOS_PATHMUSTEXIST | FOS_ALLOWMULTISELECT
   dialogOptions := 0x8 | 0x200 ; FOS_NOCHANGEDIR | FOS_ALLOWMULTISELECT
   dialogOptions |= (pickFoldersOnly=1) ? 0x20 : 0x1000    ; FOS_PICKFOLDERS : FOS_FILEMUSTEXIST

   DllCall(NumGet(VTBL + SetOptions, "UPtr"), "Ptr", FileDialog, "UInt", dialogOptions, "UInt")
   If StartingFolder
   {
      If !DllCall("Shell32.dll\SHCreateItemFromParsingName", "WStr", StartingFolder, "Ptr", 0, "Ptr", &IID_IShellItem, "PtrP", FolderItem)
         DllCall(NumGet(VTBL + SetFolder, "UPtr"), "Ptr", FileDialog, "Ptr", FolderItem, "UInt")
   }

   If Prompt
      DllCall(NumGet(VTBL + SetTitle, "UPtr"), "Ptr", FileDialog, "WStr", Prompt, "UInt")
   If OkBtnLabel
      DllCall(NumGet(VTBL + SetOkButtonLabel, "UPtr"), "Ptr", FileDialog, "WStr", OkBtnLabel, "UInt")

   If CustomPlaces
   {
      Loop, Parse, CustomPlaces, `n
      {
          If InStr(FileExist(A_LoopField), "D")
          {
             foo := 1, Directory := A_LoopField
             DllCall("Shell32.dll\SHParseDisplayName", "UPtr", &Directory, "Ptr", 0, "UPtrP", PIDL, "UInt", 0, "UInt", 0)
             DllCall("Shell32.dll\SHCreateShellItem", "Ptr", 0, "Ptr", 0, "UPtr", PIDL, "UPtrP", IShellItem)
             ObjRawSet(ComDlgObj, IShellItem, PIDL)
             ; IFileDialog::AddPlace method
             ; https://msdn.microsoft.com/en-us/library/windows/desktop/bb775946(v=vs.85).aspx
             DllCall(NumGet(NumGet(FileDialog+0)+21*A_PtrSize), "UPtr", FileDialog, "UPtr", IShellItem, "UInt", foo)
          }
      }
   }
;/*
   If (comboList && comboLabel)
   {
      Try If ((FileDialogCustomize := ComObjQuery(FileDialog, "{e6fdd21a-163f-4975-9c8c-a69f1ba37034}")))
      {
         groupId := 616 ; arbitrarily chosen IDs
         comboboxId := 93270
         DllCall(NumGet(NumGet(FileDialogCustomize+0)+26*A_PtrSize), "Ptr", FileDialogCustomize
                , "UInt", groupId, "WStr", comboLabel) ; IFileDialogCustomize::StartVisualGroup
         DllCall(NumGet(NumGet(FileDialogCustomize+0)+6*A_PtrSize), "Ptr", FileDialogCustomize
                    , "UInt", comboboxId) ; IFileDialogCustomize::AddComboBox
          DllCall(NumGet(NumGet(FileDialogCustomize+0)+19*A_PtrSize), "Ptr", FileDialogCustomize
          , "UInt", comboboxId, "UInt", itemOneId, "WStr", "Current folder") ; IFileDialogCustomize::AddControlItem
         
         entriesArray := []
         Loop, Parse, comboList,`n
         {
             Random, varA, 2, 900
             Random, varB, 2, 900
             thisID := varA varB
             If A_LoopField
             {
                If (A_Index=desiredDefault)
                   desiredIDdefault := thisID

                entriesArray[thisId] := A_LoopField
                DllCall(NumGet(NumGet(FileDialogCustomize+0)+19*A_PtrSize), "Ptr", FileDialogCustomize, "UInt"
                                         , comboboxId, "UInt", thisID, "WStr", A_LoopField)
             }
         }

         DllCall(NumGet(NumGet(FileDialogCustomize+0)+25*A_PtrSize), "Ptr", FileDialogCustomize, "UInt", comboboxId
                                       , "UInt", desiredIDdefault) ; IFileDialogCustomize::SetSelectedControlItem
         DllCall(NumGet(NumGet(FileDialogCustomize+0)+27*A_PtrSize), "Ptr", FileDialogCustomize)
                                                                           ; IFileDialogCustomize::EndVisualGroup
      }

   }
;*/

    ;SelectedFolder:= ""
   If !If DllCall(NumGet(VTBL + Show, "UPtr"), "Ptr", FileDialog, "Ptr", OwnerHwnd, "UInt")
   ;return
    ;SetTimer, getSelFolder, -0
         ;While !SelectedFolder && A_Index < 9
            ;sleep, 900
            ;ControlGetText, SelectedFolder, Edit1, ahk_class #32770 ahk_exe autohotkey.exe ;ahk_id %OwnerHwnd%
    ;MsgBox % Selectedfolder
;/*
    If !DllCall(GetDisplayName, "Ptr", ShellItem, "UInt", 0x80028000, "PtrP", StrPtr) ; SIGDN_DESKTOPABSOLUTEPARSING
           SelectedFolder := StrGet(StrPtr, "UTF-16"), DllCall("Ole32.dll\CoTaskMemFree", "Ptr", StrPtr)
                ;Gosub getSelFolder
                ;MsgBox % Selectedfolder
      If !DllCall(NumGet(VTBL + GetResult, "UPtr"), "Ptr", FileDialog, "PtrP", ShellItem, "UInt")
      {
        ;SoundBeep, 8000
        ;WinGetActiveTitle, wT
        ;MsgBox % wT
         GetDisplayName := NumGet(NumGet(ShellItem + 0, "UPtr"), A_PtrSize * 5, "UPtr")
         If !DllCall(GetDisplayName, "Ptr", ShellItem, "UInt", 0x80028000, "PtrP", StrPtr) ; SIGDN_DESKTOPABSOLUTEPARSING
           SelectedFolder := StrGet(StrPtr, "UTF-16"), DllCall("Ole32.dll\CoTaskMemFree", "Ptr", StrPtr)
        !SelectedFolder
            ? DllCall(NumGet(VTBL + SetTitle, "UPtr"), "Ptr", FileDialog, "WStr", SelectedFolder, "UInt"): "" ; added
        ;InStr(FileExist("C:\Users\RRR\My Ahk-s"), "D", 1)
            ;? "": SelectedFolder:= "" ; not needed, Dialog will propmpt by itself if folder doesn't exist
;*/
         ObjRelease(ShellItem)
         if (FileDialogCustomize)
         {
            if (DllCall(NumGet(NumGet(FileDialogCustomize+0)+24*A_PtrSize), "Ptr", FileDialogCustomize
                                                , "UInt", comboboxId, "UInt*", selectedItemId) == 0)
            { ; IFileDialogCustomize::GetSelectedControlItem
               if selectedItemId
                  thisComboSelected := entriesArray[selectedItemId]
            }   
         }
      }
        ;If !SelectedFolder
            ;Gosub getSelFolder
            
   If (FolderItem)
      ObjRelease(FolderItem)

   if (FileDialogCustomize)
      
      ObjRelease(FileDialogCustomize)

   ObjRelease(FileDialog)
   ;r := []
   ;r.SelectedDir := SelectedFolder
   ;r.SelectedCombo := thisComboSelected
   ;pa(selectedDir), 
   ;pa(r)
   Return {SelectedDir: SelectedFolder, SelectedCombo: thisComboSelected}
}

Init:
PreSetPaths:=
(   LTrim
   "FileName_Path
    Path_FileName
    FileName
    FileName_Path_R
    Path_FileName_R"
)

Haystack:=
    ( LTrim
    "The Road Not Taken
    BY ROBERT FROST
    Two roads diverged in a yellow wood,
    And sorry I could not travel both
    And be one traveler, long I stood
    And looked down one as far as I could
    To where it bent in the undergrowth;
    Then took the other, as just as fair,
    And having perhaps the better claim,
    Because it was grassy and wanted wear;
    Though as for that the passing there
    Had worn them really about the same,
    And both that morning equally lay
    In leaves no step had trodden black.
    Oh, I kept the first for another day!
    Yet knowing how way leads on to way,
    I doubted if I should ever come back.
    I shall be telling this with a sigh
    Somewhere ages and ages hence:
    Two roads diverged in a wood, and I—
    I took the one less traveled by,
    And that has made all the difference."
)

    ;FileRead, Haystack, C:\Program Files\AutoHotkey\license.txt
FileRead, Haystack, C:\Users\RRR\My Ahk-s\Scintilla Docs.txt ; https://www.scintilla.org/ScintillaDoc.html#SCI_GETCHARAT
    ;FileRead, Haystack, Wordlist_W.txt ; https://www.autohotkey.com/boards/viewtopic.php?p=358894#p358894
    
    theHay:= Haystack
    ;theHay:= "ファイル`nĞÇİÜğiıüçöıağzIİstanbulŞeddeşalaişİİİİiÜçIIıııİİiiiIIİi`n" Haystack
    History.InsertAt(++HP, theHay), ++HT>HM? (History.RemoveAt(HB), HT:=HM, HP>HM? HP:=HM: ""): ""
  , (HP<HT-5)? LastPos:= HP: ""
Return

